<template>
  <div class="box-graphics">
    <div class="d-flex justify-end">
      <seguimiento class="ml-5"></seguimiento>
    </div>
    <h3 class="text-center tway-header-1">Engagement</h3>
    <div class="resumen">
      <div class="resumen-detail">
        <div class="tway-violet--text mb-4">
          <span style="font-size: 18px">Resumen</span>
        </div>
        <!--
        <div
          class="resumen-detail-item"
          v-for="(itemResumen, i) in summaryKPINegocio.resumen"
          :key="i"
        >
          <div>{{ itemResumen.description }}</div>
          <div>{{ itemResumen.value }}</div>
          <div>
            <span v-if="itemResumen.signo === '+'" class="material-icons">
              <v-img
                width="25"
                :src="require('@/assets/img/pmo/up-arrow-green.svg')"
              />
            </span>
            <span v-else>
              <v-img
                width="25"
                :src="require('@/assets/img/pmo/down-arrow-red.svg')"
            /></span>
          </div>
        </div>
        -->
      </div>
      <div class="resumen-bar">
        <!--
        <VueApexCharts
          :series="summaryKPINegocio.series"
          :options="summaryKPINegocio.options"
          height="150"
          type="bar"
          class="full"
        />
        -->
      </div>
    </div>
    <div class="graphics-container-triple">
      <div class="tway-violet--text">Retención de Clientes</div>
      <div>
        <div>
          <div class="mx-4 mt-1 pt-2 tway-violet--text">
            <p>
              Tasa de retención
              <ToolTips
                description="Reducción costos en ejecución de procesos con herramientas
                  tecnológicas digitales"
              />
            </p>
          </div>
          <div>
            <VueApexCharts
              :series="chartRetentionRate.series"
              :options="chartRetentionRate.options"
              height="300"
              type="area"
            />
          </div>
        </div>
        <div>
          <div class="mx-4 mt-1 pt-2 tway-violet--text">
            <p>
              Tasa de conversión
              <ToolTips
                description="Reducción costos en ejecución de procesos con herramientas
                  tecnológicas digitales"
              />
            </p>
          </div>
          <div>
            <VueApexCharts
              :series="chartConversionRate.series"
              :options="chartConversionRate.options"
              height="300"
              type="area"
            />
          </div>
        </div>
        <div>
          <div class="mx-4 mt-1 pt-2 tway-violet--text">
            <p>
              Tasa de win back
              <ToolTips
                description="Reducción costos en ejecución de procesos con herramientas
                  tecnológicas digitales"
              />
            </p>
          </div>
          <div>
            <VueApexCharts
              :series="chartWinBackRate.series"
              :options="chartWinBackRate.options"
              height="300"
              type="area"
            />
          </div>
        </div>
      </div>
    </div>
    <div class="graphics-container-duo">
      <div class="tway-violet--text">Valor de la Vida del Cliente</div>
      <div>
        <div>
          <div class="mx-4 mt-1 pt-2 tway-violet--text">
            <p>
              $ LTV de cliente digital
              <ToolTips
                description="Reducción costos en ejecución de procesos con herramientas
                  tecnológicas digitales"
              />
            </p>
          </div>
          <div>
            <VueApexCharts
              type="heatmap"
              height="300"
              :series="chartDigitalClient.series"
              :options="chartDigitalClient.options"
            />
          </div>
        </div>
        <div>
          <div class="mx-4 mt-1 pt-2 tway-violet--text">
            <p>
              % mejora de LTV por metodologías ágiles
              <ToolTips
                description="Reducción costos en ejecución de procesos con herramientas
                  tecnológicas digitales"
              />
            </p>
          </div>
          <div>
            <VueApexCharts
              v-if="chartAgileMethodologies.series.length > 0"
              :series="chartAgileMethodologies.series"
              :options="chartAgileMethodologies.options"
              height="300"
              type="bar"
            />
          </div>
        </div>
      </div>
    </div>
    <div class="graphics-container-triple">
      <div class="tway-violet--text">XXXXXXXXXXXX</div>
      <div>
        <div>
          <div class="mx-4 mt-1 pt-2 tway-violet--text">
            <p>
              Adherencia metodologías
              <ToolTips
                description="Reducción costos en ejecución de procesos con herramientas
                  tecnológicas digitales"
              />
            </p>
          </div>
          <div>
            <VueApexCharts
              :series="chartAdherenceMethodologies.series"
              :options="chartAdherenceMethodologies.options"
              height="300"
              type="radialBar"
            />
          </div>
        </div>
        <div>
          <div class="mx-4 mt-1 pt-2 tway-violet--text">
            <p>
              Adopción tecnologías
              <ToolTips
                description="Reducción costos en ejecución de procesos con herramientas
                  tecnológicas digitales"
              />
            </p>
          </div>
          <div>
            <VueApexCharts
              :series="chartTechnologyAdoption.series"
              :options="chartTechnologyAdoption.options"
              height="300"
              type="radialBar"
            />
          </div>
        </div>
        <div>
          <div class="mx-4 mt-1 pt-2 tway-violet--text">
            <p>
              Tasa de conversión
              <ToolTips
                description="Reducción costos en ejecución de procesos con herramientas
                  tecnológicas digitales"
              />
            </p>
          </div>
          <div>
            <VueApexCharts
              :series="chartCircleConversionRate.series"
              :options="chartCircleConversionRate.options"
              height="300"
              type="radialBar"
            />
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import Seguimiento from "../../components/pmo/engagement/seguimiento.vue";
import EngagementService from "../../services/pmo/engagement/engagementService";
import VueApexCharts from "vue-apexcharts";
import ToolTips from "../../components/pmo/utils/ToolTips";

export default {
  name: "Engagement",
  components: {
    Seguimiento,
    VueApexCharts,
    ToolTips,
  },
  data() {
    return {
      chartSummaryEngagement: {
        series: [],
        options: {
          series: [
            {
              name: "% Retensión",
              data: [32, 38, 43, 46, 30, 35, 23, 31, 34, 32, 41, 45],
            },
          ],
          chart: {
            height: 450,
            type: "area",
            stacked: false,
            zoom: { enabled: false },
          },
          dataLabels: { enabled: false },
          stroke: {
            width: [2],
            curve: "smooth",
            dashArray: [0],
          },
          markers: { size: 3 },
          title: {
            text: undefined,
          },
          grid: {
            row: {
              colors: ["#f3f3f3", "transparent"], // takes an array which will be repeated on columns
              opacity: 1.8,
            },
          },
          xaxis: {
            categories: [
              "Enero",
              "Febrero",
              "Marzo",
              "Abril",
              "Mayo",
              "Junio",
              "Julio",
              "Agosto",
              "Septiembre",
              "Octubre",
              "Noviembre",
              "Diciembre",
            ],
          },
          colors: ["#16C62E"],
          yaxis: [
            {
              axisTicks: { show: true },
              axisBorder: {
                show: true,
                color: "#16C62E",
              },
              labels: { style: { colors: "#16C62E" } },
              title: {
                text: "Retensión",
                style: { color: "#16C62E" },
              },
              max: 100,
              min: 0,
              tooltip: { enabled: true },
            },
          ],
          tooltip: {
            fixed: {
              enabled: true,
              position: "topLeft", // topRight, topLeft, bottomRight, bottomLeft
              offsetY: 30,
              offsetX: 60,
            },
          },
          legend: {
            horizontalAlign: "left",
            offsetX: 40,
          },
        },
      },
      chartRetentionRate: {
        series: [],
        options: {
          chart: {
            height: 450,
            type: "area",
            stacked: false,
            zoom: { enabled: false },
          },
          dataLabels: { enabled: false },
          stroke: {
            width: [2],
            curve: "smooth",
            dashArray: [0],
          },
          markers: { size: 3 },
          title: {
            text: undefined,
          },
          grid: {
            row: {
              colors: ["#f3f3f3", "transparent"], // takes an array which will be repeated on columns
              opacity: 1.8,
            },
          },
          xaxis: {
            categories: [
              "Enero",
              "Febrero",
              "Marzo",
              "Abril",
              "Mayo",
              "Junio",
              "Julio",
              "Agosto",
              "Septiembre",
              "Octubre",
              "Noviembre",
              "Diciembre",
            ],
          },
          colors: ["#16C62E"],
          yaxis: [
            {
              axisTicks: { show: true },
              axisBorder: {
                show: true,
                color: "#16C62E",
              },
              labels: { style: { colors: "#16C62E" } },
              title: {
                text: "Retensión",
                style: { color: "#16C62E" },
              },
              max: 100,
              min: 0,
              tooltip: { enabled: true },
            },
          ],
          tooltip: {
            fixed: {
              enabled: true,
              position: "topLeft", // topRight, topLeft, bottomRight, bottomLeft
              offsetY: 30,
              offsetX: 60,
            },
          },
          legend: {
            horizontalAlign: "left",
            offsetX: 40,
          },
        },
      },
      chartConversionRate: {
        series: [],
        options: {
          series: [
            {
              name: "Conversión",
              data: [27, 28, 26, 32, 31, 43, 46, 46, 38, 42, 48, 50],
            },
          ],
          chart: {
            height: 450,
            type: "area",
            zoom: { enabled: false },
          },
          dataLabels: { enabled: false },
          stroke: {
            width: [2],
            curve: "smooth",
            dashArray: [0],
          },
          markers: { size: 3 },
          title: {
            text: undefined,
          },
          grid: {
            row: {
              colors: ["#f3f3f3", "transparent"], // takes an array which will be repeated on columns
              opacity: 1.8,
            },
          },
          xaxis: {
            categories: [
              "Enero",
              "Febrero",
              "Marzo",
              "Abril",
              "Mayo",
              "Junio",
              "Julio",
              "Agosto",
              "Septiembre",
              "Octubre",
              "Noviembre",
              "Diciembre",
            ],
          },
          colors: [
            "#7319D5",
            "#B2B2B2",
            "#AEEA00",
            "#4A148C",
            "#7F7F7F",
            "#16C62E",
          ],
          yaxis: [
            {
              axisTicks: { show: true },
              axisBorder: {
                show: true,
                color: "#7319D5",
              },
              labels: { style: { colors: "#7319D5" } },
              title: {
                text: "Conversión",
                style: { color: "#7319D5" },
              },
              tooltip: { enabled: true },
              max: 100,
              min: 0,
            },
          ],
          tooltip: {
            fixed: {
              enabled: true,
              position: "topLeft", // topRight, topLeft, bottomRight, bottomLeft
              offsetY: 30,
              offsetX: 60,
            },
          },
          legend: {
            horizontalAlign: "left",
            offsetX: 40,
          },
        },
      },
      chartWinBackRate: {
        series: [],
        options: {
          series: [
            {
              name: "% Predictibilidad",
              data: [17, 28, 36, 55, 81, 69, 76, 63, 72, 76, 81, 79],
            },
          ],
          chart: {
            height: 450,
            type: "area",
            zoom: { enabled: false },
          },
          dataLabels: { enabled: false },
          stroke: {
            width: [2],
            curve: "smooth",
            dashArray: [0],
          },
          markers: { size: 3 },
          title: {
            text: undefined,
          },
          grid: {
            row: {
              colors: ["#f3f3f3", "transparent"], // takes an array which will be repeated on columns
              opacity: 1.8,
            },
          },
          xaxis: {
            categories: [
              "Enero",
              "Febrero",
              "Marzo",
              "Abril",
              "Mayo",
              "Junio",
              "Julio",
              "Agosto",
              "Septiembre",
              "Octubre",
              "Noviembre",
              "Diciembre",
            ],
          },
          colors: [
            "#7F7F7F",
            "#16C62E",
            "#7319D5",
            "#B2B2B2",
            "#4A148C",
            "#AEEA00",
          ],
          yaxis: [
            {
              axisTicks: { show: true },
              axisBorder: {
                show: true,
                color: "#7F7F7F",
              },
              labels: { style: { colors: "#7F7F7F" } },
              title: {
                text: "Predictibilidad",
                style: { color: "#7F7F7F" },
              },
              tooltip: { enabled: true },
              max: 100,
              min: 0,
            },
          ],
          tooltip: {
            fixed: {
              enabled: true,
              position: "topLeft", // topRight, topLeft, bottomRight, bottomLeft
              offsetY: 30,
              offsetX: 60,
            },
          },
          legend: {
            horizontalAlign: "left",
            offsetX: 40,
          },
        },
      },
      chartDigitalClient: {
        series: [],
        options: {
          chart: {
            height: 450,
            type: "heatmap",
            zoom: { enabled: false },
            toolbar: { show: false, tools: { download: false } },
          },
          dataLabels: {
            enabled: false,
          },
          colors: [
            "#7F7F7F",
            "#16C62E",
            "#7319D5",
            "#B2B2B2",
            "#4A148C",
            "#AEEA00",
          ].reverse(),
          xaxis: {
            type: "category",
            categories: [
              "0",
              "1",
              "2",
              "3",
              "4",
              "5",
              "6",
              "7",
              "8",
              "9",
              "10",
              "11",
              "12",
            ],
          },
          title: {
            text: undefined,
          },
          grid: {
            padding: {
              right: 20,
            },
          },
        },
      },
      chartAgileMethodologies: {
        series: [],
        options: {
          series: [
            {
              name: "LTV",
              data: [43, 54, 62, 72, 88, 100, 31, 39, 43, 48, 61, 66, 69],
            },
          ],
          chart: {
            type: "bar",
            height: 450,
            stacked: false,
            zoom: { enabled: false },
            toolbar: { show: false, tools: { download: false } },
          },
          colors: [
            "#16C62E",
            "#7319D5",
            "#B2B2B2",
            "#4A148C",
            "#AEEA00",
            "#7F7F7F",
          ],
          plotOptions: {
            bar: {
              horizontal: true,
              borderRadius: 2,
              columnWidth: "100%",
              barHeight: "100%",
              distributed: false,
            },
          },
          stroke: {
            width: 1,
            colors: ["#fff"],
          },
          title: {
            text: undefined,
          },
          xaxis: {
            categories: [
              "Julio 2021",
              "Agosto 2021",
              "Septiembre 2021",
              "Octubre 2021",
              "Noviembre 2021",
              "Diciembre 2021",
              "Enero 2022",
              "Febrero 2022",
              "Marzo 2022",
              "Abril 2022",
              "Mayo 2022",
              "Junio 2022",
              "Julio 2022",
            ],
            labels: {
              formatter: function (val) {
                return val;
              },
            },
          },
          yaxis: {
            min: 0,
            max: 100,
            title: {
              text: undefined,
            },
          },
          tooltip: {
            y: {
              formatter: function (val) {
                return val + " %";
              },
            },
          },
          fill: {
            opacity: 0.7,
            type: "solid",
            legend: {
              position: "top",
              horizontalAlign: "left",
              offsetX: 40,
            },
          },
        },
      },
      chartAdherenceMethodologies: {
        series: [],
        options: {
          series: [75],
          chart: {
            height: 350,
            type: "radialBar",
            colors: ["#ffffff"],
            zoom: { enabled: false },
            toolbar: { show: false, tools: { download: false } },
          },
          plotOptions: {
            radialBar: {
              startAngle: -135,
              endAngle: 225,
              colors: ["#ffffff"],
              hollow: {
                margin: 0,
                size: "60%",
                background: "#fff",
                image: undefined,
                imageOffsetX: 0,
                imageOffsetY: 0,
                position: "front",
                /*dropShadow: {
                  enabled: true,
                  top: 3,
                  left: 0,
                  blur: 4,
                  opacity: 0.24
                }*/
              },
              track: {
                background: "#fff",
                colors: ["#ffffff"],
                strokeWidth: "67%",
                margin: 0, // margin is in pixels
                dropShadow: {
                  enabled: true,
                  top: -3,
                  left: 0,
                  blur: 4,
                  opacity: 0.05,
                },
              },

              dataLabels: {
                show: true,
                name: {
                  offsetY: -10,
                  show: true,
                  color: "#888",
                  fontSize: "17px",
                },
                value: {
                  formatter: function (val) {
                    return parseInt(val);
                  },
                  color: "#111",
                  fontSize: "36px",
                  show: true,
                },
              },
            },
          },
          fill: {
            //colors: [ '#7F7F7F', '#4A148C','#16C62E', '#7319D5', '#AEEA00' ],
            colors: ["#7319D5"],
            type: "solid",
          },
          stroke: { lineCap: "round" },
          labels: ["%"],
        },
      },
      chartTechnologyAdoption: {
        series: [],
        options: {
          series: [83],
          chart: {
            height: 350,
            type: "radialBar",
            color: ["#4A148C"],
            zoom: { enabled: false },
            toolbar: { show: false, tools: { download: false } },
          },
          plotOptions: {
            radialBar: {
              startAngle: -135,
              endAngle: 225,
              hollow: {
                margin: 0,
                size: "60%",
                background: "#fff",
                image: undefined,
                imageOffsetX: 0,
                imageOffsetY: 0,
                position: "front",
                /* dropShadow: {
                   enabled: true,
                   top: 3,
                   left: 0,
                   blur: 4,
                   opacity: 0.24
                 }*/
              },
              track: {
                background: "#fff",
                strokeWidth: "100%",
                margin: 0, // margin is in pixels
                dropShadow: {
                  enabled: true,
                  top: -3,
                  left: 0,
                  blur: 4,
                  opacity: 0.05,
                },
              },

              dataLabels: {
                show: true,
                name: {
                  offsetY: -10,
                  show: true,
                  color: "#888",
                  fontSize: "17px",
                },
                value: {
                  formatter: function (val) {
                    return parseInt(val);
                  },
                  color: "#111",
                  fontSize: "36px",
                  show: true,
                },
              },
            },
          },
          fill: {
            //colors: [ '#7F7F7F', '#4A148C','#16C62E', '#7319D5', '#AEEA00' ],
            colors: ["#16C62E"],
            type: "solid",
          },
          stroke: {
            lineCap: "round",
          },
          labels: ["%"],
        },
      },
      chartCircleConversionRate: {
        series: [],

        options: {
          series: [55],
          chart: {
            height: 350,
            type: "radialBar",
            zoom: { enabled: false },
            toolbar: { show: false, tools: { download: false } },
          },
          plotOptions: {
            radialBar: {
              startAngle: -135,
              endAngle: 225,
              hollow: {
                margin: 0,
                size: "60%",
                background: "#fff",
                image: undefined,
                imageOffsetX: 0,
                imageOffsetY: 0,
                position: "front",
                /*dropShadow: {
                  enabled: true,
                  top: 3,
                  left: 0,
                  blur: 4,
                  opacity: 0.24
                }*/
              },
              track: {
                background: "#fff",
                strokeWidth: "100%",
                margin: 0, // margin is in pixels
                dropShadow: {
                  enabled: true,
                  top: -3,
                  left: 0,
                  blur: 4,
                  opacity: 0.05,
                },
              },

              dataLabels: {
                show: true,
                name: {
                  offsetY: -10,
                  show: true,
                  color: "#888",
                  fontSize: "17px",
                },
                value: {
                  formatter: function (val) {
                    return parseInt(val);
                  },
                  color: "#111",
                  fontSize: "36px",
                  show: true,
                },
              },
            },
          },
          fill: {
            //colors: [ '#7F7F7F', '#4A148C','#16C62E', '#7319D5', '#AEEA00' ],
            colors: ["#7F7F7F"],
            type: "solid",
          },
          stroke: {
            lineCap: "round",
          },
          labels: ["%"],
        },
      },
    };
  },

  methods: {
    async callService() {
      await EngagementService.getSummaryEngagement()
        .then((data) => {
          this.chartSummaryEngagement.series = data.series;
        })
        .catch((err) => console.dir(err));

      await EngagementService.getRetentionRate()
        .then((data) => {
          this.chartRetentionRate.series = data.series;
        })
        .catch((err) => console.dir(err));

      await EngagementService.getConversionRate()
        .then((data) => {
          this.chartConversionRate.series = data.series;
        })
        .catch((err) => console.dir(err));

      await EngagementService.getWinBackRate()
        .then((data) => {
          this.chartWinBackRate.series = data.series;
        })
        .catch((err) => console.dir(err));
      await EngagementService.getDigitalClient()
        .then((data) => {
          this.chartDigitalClient.series = data.series;
        })
        .catch((err) => console.dir(err));
      await EngagementService.getAgileMethodologies()
        .then((data) => {
          this.chartAgileMethodologies.series = data.series;
        })
        .catch((err) => console.dir(err));
      await EngagementService.getAdherenceMethodologies()
        .then((data) => {
          this.chartAdherenceMethodologies.series = data.series;
        })
        .catch((err) => console.dir(err));
      await EngagementService.getTechnologyAdoption()
        .then((data) => {
          this.chartTechnologyAdoption.series = data.series;
        })
        .catch((err) => console.dir(err));
      await EngagementService.getCircleConversionRate()
        .then((data) => {
          this.chartCircleConversionRate.series = data.series;
        })
        .catch((err) => console.dir(err));
    },
  },
  async mounted() {
    this.callService();
  },
};
</script>

<style lang="scss" scoped>
.box-graphics {
  max-width: 1400px;
  min-width: 1100px;
}

.graphics {
  display: flex;
  flex-direction: column;
}

.shrink {
  width: 150px;
}

.bar {
  width: 350px;
}

.resumen {
  display: flex;
  width: 100%;
  height: 250px;
  box-shadow: 0px 3px 1px -2px rgb(0 0 0 / 20%),
    0px 2px 2px 0px rgb(0 0 0 / 14%), 0px 1px 5px 0px rgb(0 0 0 / 12%);
  border-radius: 4px;
  justify-content: center;
  margin: 25px 0px 25px 0px;
}

.resumen > .resumen-detail {
  width: 17%;
  display: flex;
  flex-direction: column;
  margin-top: 50px;
}

.resumen > .resumen-detail > .resumen-detail-item {
  width: 100%;
  display: flex;
  flex-direction: row;
  justify-content: space-between;
}

.resumen > .resumen-detail > .resumen-detail-item > div:first-child {
  display: flex;
  flex-direction: row;
  justify-content: space-between;
  width: 55%;
}

.resumen > .resumen-detail > .resumen-detail-item > div {
  display: flex;
  flex-direction: row;
  justify-content: space-between;
  width: 15%;
}

.resumen > .resumen-bar {
  display: flex;
  width: 60%;
  height: auto;
}

.resumen-title {
  display: flex;
  flex-direction: row;
  width: 100%;
  border: solid black 1px;
  justify-content: space-between;
}

.resumen-content {
  display: flex;
  flex-direction: row;
  width: 100%;
  border: solid black 1px;
  justify-content: space-between;
  margin-bottom: 15px;
}

.seguimiento {
  width: 100%;
  display: flex;
  box-shadow: 0px 3px 1px -2px rgb(0 0 0 / 20%),
    0px 2px 2px 0px rgb(0 0 0 / 14%), 0px 1px 5px 0px rgb(0 0 0 / 12%);
  border-radius: 4px;
  justify-content: center;
  margin: 25px 0px 25px 0px;
  height: 500px;
}

.seguimiento-costo {
  width: 45%;
  margin: 2px;
}

.seguimiento-periodo {
  width: 45%;
  margin: 2px;
}

.graphics-container-duo,
.graphics-container-triple {
  display: flex;
  flex-direction: column;
  justify-content: space-between;
  width: 100%;
  padding: 50px;
  margin-top: 50px;
  box-shadow: 0px 3px 1px -2px rgb(0 0 0 / 20%),
    0px 2px 2px 0px rgb(0 0 0 / 14%), 0px 1px 5px 0px rgb(0 0 0 / 12%);
  border-radius: 4px;
  margin: 25px 0px 25px 0px;
  div {
    display: flex;
    flex-direction: row;
  }
}

.graphics-container-duo {
  div {
    div {
      display: flex;
      flex-direction: column;
      width: 45%;

      div {
        width: 100%;
      }

      //border: 1px solid black;
    }
  }
}

.graphics-container-triple {
  div {
    div {
      width: 32%;
      display: flex;
      flex-direction: column;
      div {
        width: 100%;
      }

      //border: 1px solid black;
    }
  }
}
</style>
